org.apache.lucene.search

## Class ConjunctionDISI

- java.lang.Object
- - org.apache.lucene.search.DocIdSetIterator
  - - org.apache.lucene.search.ConjunctionDISI

-     public final class ConjunctionDISI
      extends DocIdSetIterator

  A conjunction of DocIdSetIterators. Requires that all of its sub-iterators must be on the same document all the time. This iterates over the doc ids that are present in each given DocIdSetIterator.
  Public only for use in `org.apache.lucene.search.spans`.
  NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

- - ### Field Summary

    - ### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

      `NO_MORE_DOCS`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `advance(int target)` Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
    `long` | `cost()` Returns the estimated cost of this `DocIdSetIterator`.
    `int` | `docID()` Returns the following: `-1` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
    `static DocIdSetIterator` | `intersectIterators(List<DocIdSetIterator> iterators)` Create a conjunction over the provided DocIdSetIterators.
    `static DocIdSetIterator` | `intersectScorers(Collection<Scorer> scorers)` Create a conjunction over the provided `Scorer`s.
    `static DocIdSetIterator` | `intersectSpans(List<Spans> spanList)` Create a conjunction over the provided `Spans`.
    `int` | `nextDoc()` Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set. NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

    - ### Methods inherited from class org.apache.lucene.search.DocIdSetIterator

      `all, empty, range, slowAdvance`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### intersectScorers

          public static DocIdSetIterator intersectScorers(Collection<Scorer> scorers)

      Create a conjunction over the provided `Scorer`s. Note that the returned `DocIdSetIterator` might leverage two-phase iteration in which case it is possible to retrieve the `TwoPhaseIterator` using `TwoPhaseIterator.unwrap(org.apache.lucene.search.DocIdSetIterator)`.

    - #### intersectIterators

          public static DocIdSetIterator intersectIterators(List<DocIdSetIterator> iterators)

      Create a conjunction over the provided DocIdSetIterators. Note that the returned `DocIdSetIterator` might leverage two-phase iteration in which case it is possible to retrieve the `TwoPhaseIterator` using `TwoPhaseIterator.unwrap(org.apache.lucene.search.DocIdSetIterator)`.

    - #### intersectSpans

          public static DocIdSetIterator intersectSpans(List<Spans> spanList)

      Create a conjunction over the provided `Spans`. Note that the returned `DocIdSetIterator` might leverage two-phase iteration in which case it is possible to retrieve the `TwoPhaseIterator` using `TwoPhaseIterator.unwrap(org.apache.lucene.search.DocIdSetIterator)`.

    - #### advance

          public int advance(int target)
                      throws IOException

      Description copied from class: `DocIdSetIterator`
      Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `DocIdSetIterator.NO_MORE_DOCS` if target is greater than the highest document number in the set.

      The behavior of this method is undefined when called with `target ≤ current`, or after the iterator has exhausted. Both cases may result in unpredicted behavior.

      When `target > current` it behaves as if written:

           int advance(int target) {
             int doc;
             while ((doc = nextDoc()) < target) {
             }
             return doc;
           }

      Some implementations are considerably more efficient than that.

      NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

      Specified by:
        `advance` in class `DocIdSetIterator`
      Throws:
        `IOException`

    - #### docID

          public int docID()

      Description copied from class: `DocIdSetIterator`
      Returns the following:
      - `-1` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
      - `DocIdSetIterator.NO_MORE_DOCS` if the iterator has exhausted.
      - Otherwise it should return the doc ID it is currently on.
      Specified by:
        `docID` in class `DocIdSetIterator`

    - #### nextDoc

          public int nextDoc()
                      throws IOException

      Description copied from class: `DocIdSetIterator`
      Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
      NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
      Specified by:
        `nextDoc` in class `DocIdSetIterator`
      Throws:
        `IOException`

    - #### cost

          public long cost()

      Description copied from class: `DocIdSetIterator`
      Returns the estimated cost of this `DocIdSetIterator`.

      This is generally an upper bound of the number of documents this iterator might match, but may be a rough heuristic, hardcoded value, or otherwise completely inaccurate.

      Specified by:
        `cost` in class `DocIdSetIterator`

Copyright © 2000-2024 Apache Software Foundation. All Rights Reserved.